package org.inbio.gwt.galleries.client.widget;

import org.inbio.gwt.galleries.client.dto.DisplayInfo;

import com.google.gwt.user.client.ui.DockPanel;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.HasVerticalAlignment;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.VerticalPanel;

public class ImageBig extends BaseMedia {

	private final int MAX_TITLE_LENGTH = 190;

	private final int MAX_INFO_LENGTH = 190;

	private HorizontalPanel mainPanel;

	private VerticalPanel infoPanel;

	private DockPanel imagePanel;

	private Image image;

	private Label title;

	private Label info1;

	private Label info2;

	private Label info3;

	private Label info4;

	private Label info5;

	private Label info6;

	private Label info7;

	private Label info8;

	/**
	 * Shows a big image with some text decorating
	 * 
	 * @param displayInfo
	 * 
	 */
	public ImageBig(DisplayInfo displayInfo) {
				
		this.setDisplayInfo(displayInfo);

		// image & description
		image = new Image();
		// image.addClickListener(this);

		imagePanel = new DockPanel();
		imagePanel.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_CENTER);
		imagePanel.setVerticalAlignment(HasVerticalAlignment.ALIGN_MIDDLE);
		imagePanel.setPixelSize(480, 480);

		imagePanel.add(image, DockPanel.CENTER);

		// info labels
		title = new Label();
		info1 = new Label();
		info2 = new Label();
		info3 = new Label();
		info4 = new Label();
		info5 = new Label();
		info6 = new Label();
		info7 = new Label();
		info8 = new Label();

		// sets the info panel
		infoPanel = new VerticalPanel();
		infoPanel.setPixelSize(200, 480);
		infoPanel.addStyleName("imagesWidget");
		infoPanel.setVerticalAlignment(HasVerticalAlignment.ALIGN_MIDDLE);
		infoPanel.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_LEFT);
		infoPanel.add(title);
		infoPanel.add(info1);
		infoPanel.add(info2);
		infoPanel.add(info3);
		infoPanel.add(info4);
		infoPanel.add(info5);
		infoPanel.add(info6);
		infoPanel.add(info7);
		infoPanel.add(info8);

		// sets the panel
		mainPanel = new HorizontalPanel();
		mainPanel.setPixelSize(680, 480);
		mainPanel.setBorderWidth(2);
		mainPanel.addStyleName("imagesWidget");

		// adds widgets
		mainPanel.add(imagePanel);
		mainPanel.add(infoPanel);

		// All composites must call initWidget() in their constructors.
		initWidget(mainPanel);

		// set image
		image.setUrl(this.getDisplayInfo().getUrl());
	
		//set info.
		this.setTexts(this.getDisplayInfo().getTitle(), 
				this.getDisplayInfo().getInfo1(), this.getDisplayInfo().getInfo2(),
				this.getDisplayInfo().getInfo3(), this.getDisplayInfo().getInfo4(), 
				this.getDisplayInfo().getInfo5(), this.getDisplayInfo().getInfo6(),
				this.getDisplayInfo().getInfo7(), this.getDisplayInfo().getInfo8());
	}

	
	public void setTexts(String titleText, String text1,
			String text2, String text3, String text4, String text5, String text6,
			String text7, String text8){
		
//	 title
		if (titleText != null) {
			image.setTitle(titleText);
			if (titleText.length() < MAX_TITLE_LENGTH)
				title.setText(titleText);
			else
				title.setText(titleText.substring(0, MAX_TITLE_LENGTH - 1));
			title.addStyleName("imaName");
		}

		// info1 == whatever
		if (text1 != null) {
			if (text1.length() < MAX_INFO_LENGTH)
				info1.setText(text1);
			else
				info1.setText(text1.substring(0, MAX_INFO_LENGTH - 1));
			info1.setStyleName("imaInfo");
		}

		// info2 == whatever
		if (text2 != null) {
			if (text2.length() < MAX_INFO_LENGTH)
				info2.setText(text2);
			else
				info2.setText(text2.substring(0, MAX_INFO_LENGTH - 1));
			info2.setStyleName("imaInfo");
		}

		info3.setText(text3);
		info3.setStyleName("imaInfo");
		info4.setText(text4);
		info4.setStyleName("imaInfo");
		info5.setText(text5);
		info5.setStyleName("imaInfo");
		info6.setText(text6);
		info6.setStyleName("imaInfo");
		info7.setText(text7);
		info7.setStyleName("imaInfo");
		info8.setText(text8);
		info8.setStyleName("imaInfo");
		
	}


}
