package org.inbio.gwt.galleries.client.widget;

import org.inbio.gwt.galleries.client.dto.DisplayInfo;

import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.DockPanel;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.HasVerticalAlignment;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;

public class ImageThumbnail extends BaseMedia implements ClickListener {

	private final int MAX_TITLE_LENGTH = 20;

	private final int MAX_INFO_LENGTH = 25;

	private HorizontalPanel mainPanel;
	
	private VerticalPanel leftPanel;
	
	private Image typeImage;
	
	private VerticalPanel rightPanel;

	private DockPanel imagePanel;

	private Image mainImage;

	private Label title;

	private Label info1;

	private Label info2;


	/**
	 * Shows a mainImage thumbnail with some text decorating
	 * 
	 * @param displayInfoBrief
	 */
	public ImageThumbnail(DisplayInfo displayInfo) {

		this.setDisplayInfo(displayInfo);
		
		//left Panel
		typeImage = new Image(displayInfo.getType().getImageURL());
		leftPanel = new VerticalPanel();
		leftPanel.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_RIGHT);
		leftPanel.setVerticalAlignment(HasVerticalAlignment.ALIGN_TOP);
		leftPanel.add(typeImage);
		
		//right panel
		
		
		// mainImage & description
		mainImage = new Image();
		mainImage.addClickListener(this);

		imagePanel = new DockPanel();
		imagePanel.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_CENTER);
		imagePanel.setVerticalAlignment(HasVerticalAlignment.ALIGN_MIDDLE);
		imagePanel.setPixelSize(170, 170);

		imagePanel.add(mainImage, DockPanel.CENTER);

		// info labels
		title = new Label();
		info1 = new Label();
		info2 = new Label();

		// sets the rightPanel
		rightPanel = new VerticalPanel();
		rightPanel.setStyleName("imagesRightPanel");
		rightPanel.setPixelSize(170, 220);

		// adds widgets
		rightPanel.add(imagePanel);
		rightPanel.add(title);
		rightPanel.add(info1);
		rightPanel.add(info2);

		// All composites must call initWidget() in their constructors.
		mainPanel = new HorizontalPanel();
		mainPanel.add(leftPanel);
		mainPanel.add(rightPanel);
		mainPanel.addStyleName("thumb");
		initWidget(mainPanel);

		realConstructor(this.getDisplayInfo().getUrl(), 
				this.getDisplayInfo().getTitle(),
				this.getDisplayInfo().getInfo1(), 
				this.getDisplayInfo().getInfo2());
	}

	/**
	 * 
	 * @param imageURL
	 * @param titleText
	 * @param text2
	 */
	private void realConstructor(String imageURL, String titleText, String text1,
			String text2) {

		// mainImage & description
		mainImage.setUrl(imageURL);

		// title
		if (titleText != null) {
			mainImage.setTitle(titleText);
			title.setText(titleText);
			//if (titleText.length() < MAX_TITLE_LENGTH)
			//	title.setText(titleText);
			//else
			//	title.setText(titleText.substring(0, MAX_TITLE_LENGTH - 1));
			title.addStyleName("imaName");
		}

		// info1 == whatever
		if (text1 != null) {
			info1.setText(text1);
			//if (text1.length() < MAX_INFO_LENGTH)
			//	info1.setText(text1);
			//else
			//	info1.setText(text1.substring(0, MAX_INFO_LENGTH - 1));
			info1.setStyleName("imaInfo");
		}

		// info2 == whatever
		if (text2 != null) {
			info2.setText(text2);
			//if (text2.length() < MAX_INFO_LENGTH)
			//	info2.setText(text2);
			//else
			//	info2.setText(text2.substring(0, MAX_INFO_LENGTH - 1));
			info2.setStyleName("imaInfo");
		}

	}

	/**
	 * If the mainImage was click.. then a new onMediaSelected event is going to be
	 * fired!
	 */
	public void onClick(Widget sender) {
		if (this.getMediaListener() != null)
			this.getMediaListener().onMediaSelected(this);
	}


}
