/**
 * 
 */
package org.inbio.gwt.galleries.client.widget;

import org.inbio.gwt.galleries.client.listener.MediaSlideListener;

import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.DialogBox;
import com.google.gwt.user.client.ui.DockPanel;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.PopupListener;
import com.google.gwt.user.client.ui.PopupPanel;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;

/**
 * This is a individual element of a slide show!
 * 
 * 
 * @author jgutierrez
 * 
 */
public class MediaSlide extends Composite implements PopupListener,
		ClickListener {

	private DialogBox background;

	private DialogBox mediaDialogBox;

	private DockPanel mainPanel;

	private Image next;

	private Image prev;

	private MediaSlideListener mediaSlideListener = null;

	/**
	 * 
	 * 
	 */
	public MediaSlide() {

		background = new DialogBox(true);
		background.setSize(Integer.toString(Window.getClientWidth()), Integer
				.toString(Window.getClientHeight()));
		background.addStyleName("opacar-pantalla");
		background.setWidget(new VerticalPanel());
		background.center();
		background.show();

		mediaDialogBox = new DialogBox(true);
		mediaDialogBox.setText("Multimedia Management System");
		mainPanel = new DockPanel();

		next = new Image("images/next.gif");
		next.addClickListener(this);
		mainPanel.add(next, DockPanel.EAST);

		prev = new Image("images/prev.gif");
		prev.addClickListener(this);
		mainPanel.add(prev, DockPanel.WEST);

		Image loading = new Image("images/loading.gif");
		mainPanel.add(loading, DockPanel.CENTER);

		mediaDialogBox.setWidget(mainPanel);
		mediaDialogBox.center();
		mediaDialogBox.show();
		mediaDialogBox.addPopupListener(this);
	}

	/**
	 * The mediaDialogBox was closed
	 */
	public void onPopupClosed(PopupPanel sender, boolean autoClosed) {
		this.background.hide();
	}

	/**
	 * adds the listener to the widget.
	 * 
	 * @param mediaSlideListener
	 */
	public void addMediaSlideListener(MediaSlideListener mediaSlideListener) {
		this.mediaSlideListener = mediaSlideListener;
	}

	/**
	 * Fires a event only if the MediaSlideListener has added
	 * 
	 */
	public void onClick(Widget sender) {

		if (this.mediaSlideListener != null) {
			
			
			if (sender.equals(this.next)) {
				this.mediaSlideListener.onNextClicked();
			}

			else if (sender.equals(prev)){
				this.mediaSlideListener.onPreviousClicked();
			}
		}

	}

	/**
	 * @param mediaWidget
	 *          the mediaWidget to set
	 */
	public void setMediaWidget(BaseMedia mediaWidget) {
		
		mainPanel.remove(mainPanel.getWidgetCount()-1);
		mainPanel.add(mediaWidget, DockPanel.CENTER);
		mediaDialogBox.center();
	}
}
