/**
 * 
 */
package org.inbio.gwt.taxonomy.client.rpc;

import java.util.List;

import org.inbio.gwt.taxonomy.client.dto.TaxonInfo;
import org.inbio.gwt.taxonomy.client.events.TaxonomyRPCException;

import com.google.gwt.user.client.rpc.RemoteService;

/**
 * @author jgutierrez
 * 
 */
public interface TaxonSelectorRPC extends RemoteService {

	/**
	 * Recibe un nombre cientifico de taxon y devuelve una lista con TaxonInfo
	 * 
	 * @param taxonName
	 * @return
	 * @throws TaxonomyRPCException
	 */
	public List<TaxonInfo> getTaxonInfo(String taxonName) throws TaxonomyRPCException;

	/**
	 * Recibe una lista de ID's de taxones y devuelve una lista con TaxonInfo
	 * 
	 * @param literalTaxonIds
	 * @return
	 * @throws TaxonomyRPCException
	 */
	public List<TaxonInfo> getTaxonsInfo(List<String> literalTaxonIds) throws TaxonomyRPCException;

}
