/**
 * 
 */
package org.inbio.gwt.taxonomy.client.widget;

import java.util.List;

import org.inbio.gwt.taxonomy.client.dto.TaxonInfo;
import org.inbio.gwt.taxonomy.client.events.TaxonListener;

import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.DialogBox;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.HasVerticalAlignment;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.ListBox;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;

/**
 * @author jgutierrez
 * 
 */
public class MultipleTaxonSelector extends DialogBox implements ClickListener {

	// private static final String HORIZONTAL_SIZE = "300";

	// private static final String VERTICAL_SIZE = "100";

	private VerticalPanel main = new VerticalPanel();

	private HorizontalPanel buttons = new HorizontalPanel();

	private String msg = "Existe más de 1 taxón asociado al nombre de taxon. "
			+ "Por favor seleccione el más adecuado.";

	private ListBox taxons = new ListBox();

	private Button ok = new Button("seleccionar", this);

	private Button cancel = new Button("cancelar", this);

	private TaxonListener listener;

	/**
	 * Class constructor
	 * 
	 * @param taxonsInfoList
	 *            a list of TaxonInfo objects
	 * @param taxonListener
	 *            where the event of selecting a taxon will be fired
	 */
	public MultipleTaxonSelector(List taxonsInfoList,
			TaxonListener taxonListener) {

		listener = taxonListener;

		main.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_CENTER);
		main.setSpacing(10);
		main.setStyleName("LoginBox-Panel");

		Label text = new Label(msg);
		main.add(text);

		TaxonInfo item;
		String display;
		for (int i = 0; i < taxonsInfoList.size(); i++) {
			item = (TaxonInfo) taxonsInfoList.get(i);
			display = item.taxonName + " [reino: " + item.kingdomName + "]";
			taxons.addItem(display, item.taxonId);
		}
		taxons.setVisibleItemCount(4);
		taxons.setSelectedIndex(0);
		main.add(taxons);

		buttons.setSpacing(10);
		buttons.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_CENTER);
		buttons.setVerticalAlignment(HasVerticalAlignment.ALIGN_MIDDLE);
		buttons.add(ok);
		buttons.add(cancel);
		main.add(buttons);

		setText("Selección de Taxonomía");
		setWidget(main);

	}

	/**
	 * event fired when any button in clicked
	 */
	public void onClick(Widget sender) {
		Button clicked = (Button) sender;

		if (clicked.equals(ok)) {

			int selectedIndex = taxons.getSelectedIndex();
			listener.onTaxonSelected(taxons.getItemText(selectedIndex), taxons
					.getValue(selectedIndex));

		}
		hide();

	}
}
